
#define FORMFEED CHR(12)
#define TESTFILE "__testFile"

PROCEDURE main()
  LOCAL oPrinter, aPrn, nPos, nStart:= 1, hPrinter, cStr, nLength, nLineLen:= 132
  CLS
  @ 0,0 SAY 'Print to printer in RAW mode'
  oPrinter:=xbpPrinter():new()
  aPrn:=oPrinter:list()
  IF EMPTY(LEN(aPrn))
    ALERT("Warning: No Printer Installed")
  ELSE
    IF !EMPTY(nPos:=  ACHOICE(1,0,20,33,aPrn))
      IF .F.   // use this option to spool a file
        memoWrit(TESTFILE, MEMOREAD("PRNTEST.PRG")+FORMFEED)
        pl_prnRaw(aPrn[nPos],TESTFILE)
        ferase(TESTFILE)
      ELSE  // send strings to the spooler
        cStr:= MEMOREAD("PRNTEST.PRG")+FORMFEED
        IF (hPrinter:= OPENRAWPRINTER(aPrn[nPos],"Name to appear in spooler")) > 0
          nLength:= LEN(cStr)
          DO WHILE nStart <= nLength
            WRITERAWPRINTER(hPrinter, SUBSTR(cStr,nStart,nLineLen))
            nStart+= nLineLen
          ENDDO
          CLOSERAWPRINTER(hPrinter)
        ENDIF
      ENDIF  
    ENDIF
  ENDIF
  RETURN

FUNCTION pl_prnRaw(cPrinter,cFileName)
  LOCAL nPrn:= -1, cMess:= "PL_RAWPRN(): "
  IF !EMPTY(cFilename)
    IF (nPrn := PrintFileRaw(cPrinter,cFilename)) < 0
      DO CASE
      CASE nPrn = -1
        Alert(cMess+"Incorrect parameters passed to function")
      CASE nPrn = -2
        Alert(cMess+"WINAPI OpenPrinter() call failed")
      CASE nPrn = -3
        Alert(cMess+"WINAPI StartDocPrinter() call failed")
      CASE nPrn = -4
        Alert(cMess+"WINAPI StartPagePrinter() call failed")
      CASE nPrn = -5
        Alert(cMess+"WINAPI malloc() of memory failed")
      CASE nPrn = -6
        Alert(cMess+"WINAPI CreateFile() call failed")
      ENDCASE
    ENDIF
  ENDIF
  RETURN(nPrn)


STATIC FUNCTION message()

TEXT

Attached is a ZIP file with a demo of printing in RAW mode plus all required
source code. Note CL.BAT and RECPP.MAK are used to compile the C program.
RECPP.MAK assumes MS Visual C.

Obviously to make use of this you need to know what type of printer you are
printing to and you must also include the appropriate "Escape codes" in the
file - as we used to do in Clipper. The trick we use to determine what type
of printer is installed is to add special characters to the Windows printer
name.

(E)= Epson compatible DOT matrix e.g. Panasonic KXP3200 Series (E)
(6)= PCL 6 compatible
(D)= Deskjet

etc.... If no recognised special characters are found in the printer name
use standard Windows GDI printing with GRA...() functions.


ENDTEXT

RETURN(.T.)