/******************************************************************************
 *
 *  RE_C.C
 *
 *  Copyright:
 *    Rees Software & Systems Ltd, (c) 1999. All rights reserved.
 *  
 *  Contents :
 *    the C-functions For incorporation into Rees2000
 *    which are callable from Xbase++
 *
 ******************************************************************************/


#include <windows.h>
#include <winspool.h>
#include <xppcon.h>

#define BIG_BUFFER (1024*32)

XPPRET XPPENTRY PRINTFILERAW(XppParamList paramList)  {
  UCHAR  cPrinterName[256], cFileName[256], *printBuffer ;
  HANDLE  hPrinter, hFile ;
  DOC_INFO_1 DocInfo ;
  DWORD nRead, nWritten, rVal = -1 ;
  if (XPP_IS_CHAR(_partype(paramList,1)) && XPP_IS_CHAR(_partype(paramList,2))) {
    _parc(cPrinterName, 255, paramList,1) ;
    _parc(cFileName, 255, paramList,2) ;
    if ( OpenPrinter(cPrinterName, &hPrinter, NULL) != 0 ) {
      DocInfo.pDocName = cFileName ;
      DocInfo.pOutputFile = NULL ;
      DocInfo.pDatatype = "RAW" ;
      if ( StartDocPrinter(hPrinter,1,(char *) &DocInfo) != 0 ) {
        if ( StartPagePrinter(hPrinter) != 0 ) {
          printBuffer = malloc(BIG_BUFFER) ;
          if ( printBuffer != NULL) {
            hFile = CreateFile(cFileName,GENERIC_READ,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL)   ;
            if (hFile != INVALID_HANDLE_VALUE ) {
              while (ReadFile(hFile, printBuffer, BIG_BUFFER, &nRead, NULL) && (nRead > 0)) 
                WritePrinter(hPrinter, printBuffer, nRead, &nWritten) ;
              rVal = 1 ;
              CloseHandle(hFile) ;
            }
            else
              rVal= -6 ;
            free(printBuffer) ;  
          }
          else
            rVal= -5 ;
        }
        else
          rVal = -4 ;
        EndDocPrinter(hPrinter);
      }
      else
        rVal= -3 ;
      ClosePrinter(hPrinter) ;
    }
    else
       rVal= -2 ;
  }
  _retnl(paramList,rVal) ;
  return ;
}


XPPRET XPPENTRY OPENRAWPRINTER(XppParamList paramList)  {
  UCHAR  cPrinterName[256], cFileName[256] ;	// address of printer or server name 
  HANDLE  hPrinter ;	// address of printer or server handle 
  DOC_INFO_1 DocInfo ;
  DWORD u = 1 ;
  if (!XPP_IS_CHAR(_partype(paramList,1)) || !XPP_IS_CHAR(_partype(paramList,2))) {
    _retnl(paramList,-1);
    return;
  }
  _parc(cPrinterName, 255, paramList,1) ;
  _parc(cFileName, 255, paramList,2) ;
  if ( OpenPrinter(cPrinterName, &hPrinter, NULL) == FALSE) {
    _retnl(paramList, -1) ;
    return ;
  }  
  DocInfo.pDocName = cFileName ;
  DocInfo.pOutputFile = NULL ;
  DocInfo.pDatatype = "RAW" ;
  if ( StartDocPrinter(hPrinter,u,(char *) &DocInfo) == FALSE ) {
    ClosePrinter(hPrinter) ;
    _retnl(paramList, -1) ;
    return ;
  }    
  if ( StartPagePrinter(hPrinter) == FALSE) {
    EndDocPrinter(hPrinter);
    ClosePrinter(hPrinter) ;
     _retnl(paramList, -1) ;
    return ;
  }    
  _retnl(paramList, (long) hPrinter) ;
  return ;
}

XPPRET XPPENTRY CLOSERAWPRINTER(XppParamList paramList)  {
  HANDLE  hPrinter ;	// address of printer or server handle 
  BOOL rVal= 0 ;
  if (!XPP_IS_NUM(_partype(paramList,1))) {
    _retl(paramList,rVal);
    return;
  }
  hPrinter =  ( HANDLE ) _parnl(paramList, 1) ;
  EndDocPrinter(hPrinter);
  rVal = ClosePrinter(hPrinter) ;
  _retl(paramList,rVal) ;
  return ;
}    

XPPRET XPPENTRY WRITERAWPRINTER(XppParamList paramList)  {
  HANDLE  hPrinter ;	// address of printer or server handle 
   ContainerHandle  cString; 
   BOOL             lByReference;   // determines if string passed by reference - if TRUE then no need to conRelease()
   UCHAR            *pointerToString ; 
   ULONG            lengthOfString, rVal= 0, nWritten= 0; 
  
  if (!XPP_IS_NUM(_partype(paramList,1)) || !XPP_IS_CHAR(_partype(paramList,2))) {
    _retl(paramList,rVal) ;
    return;
  }
  hPrinter =  ( HANDLE ) _parnl(paramList, 1) ;
  cString = _conParam( paramList, 2, &lByReference ); 
  if (cString != NULLCONTAINER ) {
    // note: _conRLockC()  Returns NULL if successful
    if ( !_conRLockC( cString, &pointerToString, &lengthOfString )) { 
      if ( lengthOfString > 0 ) {
        rVal = WritePrinter(hPrinter, pointerToString, lengthOfString, &nWritten) ;
      }  
      _conUnlockC( cString ); 
    }
    if (!lByReference ) { 
      _conRelease(cString); 
    }  
  }   
  _retl(paramList, rVal) ;
  return ;
}   
